qSort <- function( a )
{
    # number of elements to sort
    n = length( a )

    # recursive termination:
    # check if only have one element
    if( n <= 1 ) return( a )

    # choose first element as pivot
    pivot = a[1]

    less = c() # all elements < pivot
    more = c() # all elements >= pivot

    # for all other elements
    for( i in 2:n )
    {
        # place element in less sublist
        if( a[i] < pivot ) less = c( less, a[i] )

        # place element in more sublist
        else more = c( more, a[i] )
    }

    # recursively sort both sublists
    less = qSort( less )
    more = qSort( more )

    # return sorted less list,
    # then pivot,
    # then sorted more list
    return( c( less, pivot, more ) )
}

# try this:
# qSort( sample( 1:10 ) )
